Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/alglibinternal.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/alglibinternal.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/alglibinternal.cs	(revision 7294)
@@ -4370,4 +5040,47 @@
     public class hsschur
     {
+        /*************************************************************************
+        Subroutine performing  the  Schur  decomposition  of  a  matrix  in  upper
+        Hessenberg form using the QR algorithm with multiple shifts.
+
+        The  source matrix  H  is  represented as  S'*H*S = T, where H - matrix in
+        upper Hessenberg form,  S - orthogonal matrix (Schur vectors),   T - upper
+        quasi-triangular matrix (with blocks of sizes  1x1  and  2x2  on  the main
+        diagonal).
+
+        Input parameters:
+            H   -   matrix to be decomposed.
+                    Array whose indexes range within [1..N, 1..N].
+            N   -   size of H, N>=0.
+
+
+        Output parameters:
+            H      contains the matrix T.
+                    Array whose indexes range within [1..N, 1..N].
+                    All elements below the blocks on the main diagonal are equal
+                    to 0.
+            S   -   contains Schur vectors.
+                    Array whose indexes range within [1..N, 1..N].
+
+        Note 1:
+            The block structure of matrix T could be easily recognized: since  all
+            the elements  below  the blocks are zeros, the elements a[i+1,i] which
+            are equal to 0 show the block border.
+
+        Note 2:
+            the algorithm  performance  depends  on  the  value  of  the  internal
+            parameter NS of InternalSchurDecomposition  subroutine  which  defines
+            the number of shifts in the QR algorithm (analog of  the  block  width
+            in block matrix algorithms in linear algebra). If you require  maximum
+            performance  on  your  machine,  it  is  recommended  to  adjust  this
+            parameter manually.
+
+        Result:
+            True, if the algorithm has converged and the parameters H and S contain
+                the result.
+            False, if the algorithm has not converged.
+
+        Algorithm implemented on the basis of subroutine DHSEQR (LAPACK 3.0 library).
+        *************************************************************************/
         public static bool upperhessenbergschurdecomposition(ref double[,] h,
             int n,
@@ -7715,5 +8428,4 @@
         public const double ftol = 0.001;
         public const double xtol = 100*math.machineepsilon;
-        public const double gtol = 0.3;
         public const int maxfev = 20;
         public const double stpmin = 1.0E-50;
@@ -7803,4 +8515,20 @@
         ALGORITHM  USUALLY STOPS  WHEN  ROUNDING ERRORS  PREVENT FURTHER PROGRESS.
         IN THIS CASE STP ONLY SATISFIES THE SUFFICIENT DECREASE CONDITION.
+
+
+        :::::::::::::IMPORTANT NOTES:::::::::::::
+
+        NOTE 1:
+
+        This routine  guarantees that it will stop at the last point where function
+        value was calculated. It won't make several additional function evaluations
+        after finding good point. So if you store function evaluations requested by
+        this routine, you can be sure that last one is the point where we've stopped.
+
+        NOTE 2:
+
+        when 0<StpMax<StpMin, algorithm will terminate with INFO=5 and Stp=0.0
+        :::::::::::::::::::::::::::::::::::::::::
+
 
         PARAMETERS DESCRIPRION
@@ -7871,4 +8599,5 @@
             ref double stp,
             double stpmax,
+            double gtol,
             ref int info,
             ref int nfev,
@@ -7926,4 +8655,10 @@
                     //     CHECK THE INPUT PARAMETERS FOR ERRORS.
                     //
+                    if( (double)(stpmax)<(double)(stpmin) & (double)(stpmax)>(double)(0) )
+                    {
+                        info = 5;
+                        stp = 0.0;
+                        return;
+                    }
                     if( ((((((n<=0 | (double)(stp)<=(double)(0)) | (double)(ftol)<(double)(0)) | (double)(gtol)<(double)(zero)) | (double)(xtol)<(double)(zero)) | (double)(stpmin)<(double)(zero)) | (double)(stpmax)<(double)(stpmin)) | maxfev<=0 )
                     {
@@ -8798,4 +9533,59 @@
                 {
                     stp = Math.Max(stx+0.66*(sty-stx), stp);
+                }
+            }
+        }
+
+
+    }
+    public class optserv
+    {
+        /*************************************************************************
+        This subroutine is used to prepare threshold value which will be used for
+        trimming of the target function (see comments on TrimFunction() for more
+        information).
+
+        This function accepts only one parameter: function value at the starting
+        point. It returns threshold which will be used for trimming.
+
+          -- ALGLIB --
+             Copyright 10.05.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void trimprepare(double f,
+            ref double threshold)
+        {
+            threshold = 0;
+
+            threshold = 10*(Math.Abs(f)+1);
+        }
+
+
+        /*************************************************************************
+        This subroutine is used to "trim" target function, i.e. to do following
+        transformation:
+
+                           { {F,G}          if F<Threshold
+            {F_tr, G_tr} = {
+                           { {Threshold, 0} if F>=Threshold
+                           
+        Such transformation allows us to  solve  problems  with  singularities  by
+        redefining function in such way that it becomes bounded from above.
+
+          -- ALGLIB --
+             Copyright 10.05.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void trimfunction(ref double f,
+            ref double[] g,
+            int n,
+            double threshold)
+        {
+            int i = 0;
+
+            if( (double)(f)>=(double)(threshold) )
+            {
+                f = threshold;
+                for(i=0; i<=n-1; i++)
+                {
+                    g[i] = 0.0;
                 }
             }
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/alglibmisc.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/alglibmisc.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/alglibmisc.cs	(revision 7294)
@@ -214,4 +214,49 @@
             _innerobj = obj;
         }
+    }
+
+
+    /*************************************************************************
+    This function serializes data structure to string.
+
+    Important properties of s_out:
+    * it contains alphanumeric characters, dots, underscores, minus signs
+    * these symbols are grouped into words, which are separated by spaces
+      and Windows-style (CR+LF) newlines
+    * although  serializer  uses  spaces and CR+LF as separators, you can 
+      replace any separator character by arbitrary combination of spaces,
+      tabs, Windows or Unix newlines. It allows flexible reformatting  of
+      the  string  in  case you want to include it into text or XML file. 
+      But you should not insert separators into the middle of the "words"
+      nor you should change case of letters.
+    * s_out can be freely moved between 32-bit and 64-bit systems, little
+      and big endian machines, and so on. You can serialize structure  on
+      32-bit machine and unserialize it on 64-bit one (or vice versa), or
+      serialize  it  on  SPARC  and  unserialize  on  x86.  You  can also 
+      serialize  it  in  C# version of ALGLIB and unserialize in C++ one, 
+      and vice versa.
+    *************************************************************************/
+    public static void kdtreeserialize(kdtree obj, out string s_out)
+    {
+        alglib.serializer s = new alglib.serializer();
+        s.alloc_start();
+        nearestneighbor.kdtreealloc(s, obj.innerobj);
+        s.sstart_str();
+        nearestneighbor.kdtreeserialize(s, obj.innerobj);
+        s.stop();
+        s_out = s.get_string();
+    }
+
+
+    /*************************************************************************
+    This function unserializes data structure from string.
+    *************************************************************************/
+    public static void kdtreeunserialize(string s_in, out kdtree obj)
+    {
+        alglib.serializer s = new alglib.serializer();
+        obj = new kdtree();
+        s.ustart_str(s_in);
+        nearestneighbor.kdtreeunserialize(s, obj.innerobj);
+        s.stop();
     }
 
@@ -961,12 +1006,8 @@
             public int ny;
             public int normtype;
-            public int distmatrixtype;
             public double[,] xy;
             public int[] tags;
             public double[] boxmin;
             public double[] boxmax;
-            public double[] curboxmin;
-            public double[] curboxmax;
-            public double curdist;
             public int[] nodes;
             public double[] splits;
@@ -980,4 +1021,7 @@
             public double[] r;
             public double[] buf;
+            public double[] curboxmin;
+            public double[] curboxmax;
+            public double curdist;
             public int debugcounter;
             public kdtree()
@@ -987,6 +1031,4 @@
                 boxmin = new double[0];
                 boxmax = new double[0];
-                curboxmin = new double[0];
-                curboxmax = new double[0];
                 nodes = new int[0];
                 splits = new double[0];
@@ -995,4 +1037,6 @@
                 r = new double[0];
                 buf = new double[0];
+                curboxmin = new double[0];
+                curboxmax = new double[0];
             }
         };
@@ -1002,4 +1046,5 @@
 
         public const int splitnodesize = 6;
+        public const int kdtreefirstversion = 0;
 
 
@@ -1133,11 +1178,10 @@
             kdt.ny = ny;
             kdt.normtype = normtype;
-            kdt.distmatrixtype = 0;
-            kdt.xy = new double[n, 2*nx+ny];
-            kdt.tags = new int[n];
-            kdt.idx = new int[n];
-            kdt.r = new double[n];
-            kdt.x = new double[nx];
-            kdt.buf = new double[Math.Max(n, nx)];
+            
+            //
+            // Allocate
+            //
+            kdtreeallocdatasetindependent(kdt, nx, ny);
+            kdtreeallocdatasetdependent(kdt, n, nx, ny);
             
             //
@@ -1161,8 +1205,4 @@
             // Determine bounding box
             //
-            kdt.boxmin = new double[nx];
-            kdt.boxmax = new double[nx];
-            kdt.curboxmin = new double[nx];
-            kdt.curboxmax = new double[nx];
             for(i_=0; i_<=nx-1;i_++)
             {
@@ -1753,4 +1793,106 @@
 
             kdtreequeryresultsdistances(kdt, ref r);
+        }
+
+
+        /*************************************************************************
+        Serializer: allocation
+
+          -- ALGLIB --
+             Copyright 14.03.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void kdtreealloc(alglib.serializer s,
+            kdtree tree)
+        {
+            
+            //
+            // Header
+            //
+            s.alloc_entry();
+            s.alloc_entry();
+            
+            //
+            // Data
+            //
+            s.alloc_entry();
+            s.alloc_entry();
+            s.alloc_entry();
+            s.alloc_entry();
+            apserv.allocrealmatrix(s, tree.xy, -1, -1);
+            apserv.allocintegerarray(s, tree.tags, -1);
+            apserv.allocrealarray(s, tree.boxmin, -1);
+            apserv.allocrealarray(s, tree.boxmax, -1);
+            apserv.allocintegerarray(s, tree.nodes, -1);
+            apserv.allocrealarray(s, tree.splits, -1);
+        }
+
+
+        /*************************************************************************
+        Serializer: serialization
+
+          -- ALGLIB --
+             Copyright 14.03.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void kdtreeserialize(alglib.serializer s,
+            kdtree tree)
+        {
+            
+            //
+            // Header
+            //
+            s.serialize_int(scodes.getkdtreeserializationcode());
+            s.serialize_int(kdtreefirstversion);
+            
+            //
+            // Data
+            //
+            s.serialize_int(tree.n);
+            s.serialize_int(tree.nx);
+            s.serialize_int(tree.ny);
+            s.serialize_int(tree.normtype);
+            apserv.serializerealmatrix(s, tree.xy, -1, -1);
+            apserv.serializeintegerarray(s, tree.tags, -1);
+            apserv.serializerealarray(s, tree.boxmin, -1);
+            apserv.serializerealarray(s, tree.boxmax, -1);
+            apserv.serializeintegerarray(s, tree.nodes, -1);
+            apserv.serializerealarray(s, tree.splits, -1);
+        }
+
+
+        /*************************************************************************
+        Serializer: unserialization
+
+          -- ALGLIB --
+             Copyright 14.03.2011 by Bochkanov Sergey
+        *************************************************************************/
+        public static void kdtreeunserialize(alglib.serializer s,
+            kdtree tree)
+        {
+            int i0 = 0;
+            int i1 = 0;
+
+            
+            //
+            // check correctness of header
+            //
+            i0 = s.unserialize_int();
+            ap.assert(i0==scodes.getkdtreeserializationcode(), "KDTreeUnserialize: stream header corrupted");
+            i1 = s.unserialize_int();
+            ap.assert(i1==kdtreefirstversion, "KDTreeUnserialize: stream header corrupted");
+            
+            //
+            // Unserialize data
+            //
+            tree.n = s.unserialize_int();
+            tree.nx = s.unserialize_int();
+            tree.ny = s.unserialize_int();
+            tree.normtype = s.unserialize_int();
+            apserv.unserializerealmatrix(s, ref tree.xy);
+            apserv.unserializeintegerarray(s, ref tree.tags);
+            apserv.unserializerealarray(s, ref tree.boxmin);
+            apserv.unserializerealarray(s, ref tree.boxmax);
+            apserv.unserializeintegerarray(s, ref tree.nodes);
+            apserv.unserializerealarray(s, ref tree.splits);
+            kdtreealloctemporaries(tree, tree.n, tree.nx, tree.ny);
         }
 
@@ -2405,4 +2547,75 @@
 
 
+        /*************************************************************************
+        This function allocates all dataset-independent array  fields  of  KDTree,
+        i.e.  such  array  fields  that  their dimensions do not depend on dataset
+        size.
+
+        This function do not sets KDT.NX or KDT.NY - it just allocates arrays
+
+          -- ALGLIB --
+             Copyright 14.03.2011 by Bochkanov Sergey
+        *************************************************************************/
+        private static void kdtreeallocdatasetindependent(kdtree kdt,
+            int nx,
+            int ny)
+        {
+            kdt.x = new double[nx];
+            kdt.boxmin = new double[nx];
+            kdt.boxmax = new double[nx];
+            kdt.curboxmin = new double[nx];
+            kdt.curboxmax = new double[nx];
+        }
+
+
+        /*************************************************************************
+        This function allocates all dataset-dependent array fields of KDTree, i.e.
+        such array fields that their dimensions depend on dataset size.
+
+        This function do not sets KDT.N, KDT.NX or KDT.NY -
+        it just allocates arrays.
+
+          -- ALGLIB --
+             Copyright 14.03.2011 by Bochkanov Sergey
+        *************************************************************************/
+        private static void kdtreeallocdatasetdependent(kdtree kdt,
+            int n,
+            int nx,
+            int ny)
+        {
+            kdt.xy = new double[n, 2*nx+ny];
+            kdt.tags = new int[n];
+            kdt.idx = new int[n];
+            kdt.r = new double[n];
+            kdt.x = new double[nx];
+            kdt.buf = new double[Math.Max(n, nx)];
+            kdt.nodes = new int[splitnodesize*2*n];
+            kdt.splits = new double[2*n];
+        }
+
+
+        /*************************************************************************
+        This function allocates temporaries.
+
+        This function do not sets KDT.N, KDT.NX or KDT.NY -
+        it just allocates arrays.
+
+          -- ALGLIB --
+             Copyright 14.03.2011 by Bochkanov Sergey
+        *************************************************************************/
+        private static void kdtreealloctemporaries(kdtree kdt,
+            int n,
+            int nx,
+            int ny)
+        {
+            kdt.x = new double[nx];
+            kdt.idx = new int[n];
+            kdt.r = new double[n];
+            kdt.buf = new double[Math.Max(n, nx)];
+            kdt.curboxmin = new double[nx];
+            kdt.curboxmax = new double[nx];
+        }
+
+
     }
 }
